<?php
/**
* Class file for MX Custom Tabs
* 
* This file must be placed in the
* /system/extensions/ folder in your ExpressionEngine installation.
*
* @package MX Custom Tabs
* @version 0.5.1
* @author Max Lazarev <http://wiseupstudio.com>
* @copyright Copyright (c) 2007-2009 Max Lazarev
* @license http://creativecommons.org/licenses/by-sa/3.0/ Creative Commons Attribution-Share Alike 3.0 Unported
*/

if ( ! defined('EXT')) exit('Invalid file request');
define("mx_ct_version",			"0.5.1");
define("mx_ct_docs_url",			"");
define("mx_ct_addon_id",			"mx_custom_tabs");
define("mx_ct_extension_class",	"mx_custom_tabs");
define("mx_ct_cache_name",			"mx_cache");

// -----------------------------------------
//  Begin class
// -----------------------------------------
class mx_custom_tabs
{
	/**
	* Extension settings
	* @var array
	*/
	var $settings   = array();

	/**
	* Extension name
	* @var string
	*/
	var $name	 = 'MX Custom Tabs';

	/**
	* Extension version
	* @var string
	*/
	var $version	 = mx_ct_version;

	/**
	* Extension description
	* @var string
	*/
	var $description   = 'Allows you to create a custom tabs and link them to a custom fields.';

	/**
	* If $settings_exist = 'y' then a settings page will be shown in the ExpressionEngine admin
	* @var string
	*/  
	var $settings_exist  = 'y';

	/**
	* Link to extension documentation
	* @var string
	*/
	var $docs_url   = mx_ct_docs_url;


	
	function mx_custom_tabs($settings='')
	{
		global $SESS;
		$this->__construct($settings);
		//$this->settings = $this->_get_settings();
		if(isset($SESS->cache['mx_cache']) === FALSE){ $SESS->cache['mx_cache'] = array();}
	}
  
  	/**
	* PHP 5 Constructor
	*
	* @param	array|string $settings Extension settings associative array or an empty string
	*/
	function __construct($settings='')
	{
		global $IN, $SESS;

		// get the settings from our helper class
		// this returns all the sites settings
		$this->settings = $this->_get_settings();

		if(isset($SESS->cache['mx']) === FALSE){
			$SESS->cache['mx'] = array();
		}
		$this->debug = $IN->GBL('debug');
	}
	
	/**
	* Configuration for the extension settings page (Thanks2Leevi!)
	**/
	function settings_form($current)
	{
		global $DB, $DSP, $LANG, $IN, $PREFS, $SESS;
		
		// create a local variable for the site settings
		$settings = $this->_get_settings();
	
		$DSP->crumbline = TRUE;

		$DSP->title  = $LANG->line('extension_settings');
		$DSP->crumb  = $DSP->anchor(BASE.AMP.'C=admin'.AMP.'area=utilities', $LANG->line('utilities')).
		$DSP->crumb_item($DSP->anchor(BASE.AMP.'C=admin'.AMP.'M=utilities'.AMP.'P=extensions_manager', $LANG->line('extensions_manager')));

		$DSP->crumb .= $DSP->crumb_item($LANG->line('extension_settings_title') . " {$this->version}");

		$DSP->right_crumb($LANG->line('disable_extension'), BASE.AMP.'C=admin'.AMP.'M=utilities'.AMP.'P=toggle_extension_confirm'.AMP.'which=disable'.AMP.'name='.$IN->GBL('name'));

		$DSP->body = '';	
		$DSP->body .= $DSP->heading($LANG->line('extension_settings_title') . " <small>{$this->version}</small>");
		
		$DSP->body .= $DSP->form_open(
			array(
				'action' => 'C=admin'.AMP.'M=utilities'.AMP.'P=save_extension_settings',
				'name'   => 'settings_example',
				'id'     => 'settings_example'
			),
			// WHAT A M*THERF!@KING B!TCH THIS WAS
			// REMBER THE NAME ATTRIBUTE MUST ALWAYS MATCH THE FILENAME AND ITS CASE SENSITIVE
			// BUG??
			array('name' => strtolower(get_class($this)))
		);

		$DSP->body .=   $DSP->table_open(array('class' => 'tableBorder', 'border' => '0', 'style' => 'margin-top:18px; width:100%'));

		$DSP->body .=   $DSP->tr();
		$DSP->body .=   $DSP->td('tableHeading', '', '2');
		$DSP->body .=   $LANG->line("extension_settings_title");
		$DSP->body .=   $DSP->td_c();
		$DSP->body .=   $DSP->tr_c();

		$DSP->body .=   $DSP->tr();
		$DSP->body .=   $DSP->td('', '', '2');
		$DSP->body .=   "<div class='box' style='border-width:0 0 1px 0; margin:0; padding:10px 5px'><p>" . $LANG->line('extension_settings_info'). "</p></div>";
		$DSP->body .=   $DSP->td_c();
		$DSP->body .=   $DSP->tr_c();


		$site_id	= $PREFS->ini('site_id');
		
		$query_gc	= $DB->query( "SELECT group_id, group_name 
							   FROM exp_field_groups							  
							   WHERE site_id = " . $site_id);
	
		
		$query_cf	= $DB->query( "SELECT field_id, group_id, field_label, field_name 
							   FROM exp_weblog_fields							  
							   WHERE site_id = " . $site_id . "
								ORDER BY group_id" );		
	     


	   foreach ( $query_gc->result as $row_gc )
	  {
		$DSP->body .=   $DSP->tr();
		$DSP->body .=   $DSP->td('tableHeading', '45%');
		$DSP->body .=   "<p style='text-transform: capitalize;color:#fff'>" . $row_gc["group_name"] . "</p>";
		$DSP->body .=   $DSP->td_c();
		$DSP->body .=   $DSP->td('tableHeading','');
		$DSP->body .=   "<p style='text-transform: capitalize;color:#fff'>" . $LANG->line("tabs_title") . "</p>";
		$DSP->body .=   $DSP->td_c();
		$DSP->body .=   $DSP->tr_c();

		$i	= 1;
			foreach ( $query_cf->result as $row_cf )
			{
				
				if ($row_gc["group_id"] == $row_cf["group_id"]){
					$switch	= ( $i == 0 ) ? 'tableCellOne': 'tableCellTwo';

					$DSP->body .=   $DSP->tr();
					$DSP->body .=   $DSP->td($switch, '45%');
					$DSP->body .=   $DSP->qdiv('default', $row_cf["field_label"] . " <b>{" . $row_cf["field_name"] . "}</b>");
					$DSP->body .=   $DSP->td_c();

					$DSP->body .=   $DSP->td($switch);
					$DSP->body .=   $DSP->input_text( 'ct_'.$row_cf["field_id"] , ( ( isset($settings['ct_'.$row_cf["field_id"]] ) ) ? $settings['ct_'.$row_cf["field_id"]] : ''), '', '', '', '30%' );
					$DSP->body .=   $DSP->td_c();
					$DSP->body .=   $DSP->tr_c();
					$i		= ( $i == 1 ) ? 0: 1;
				}
			}			
		}		
		$DSP->body .=   $DSP->table_c();
		
		//
		if (!isset($settings['check_for_extension_updates']))
		{
		$settings['check_for_extension_updates']  = 'n';
		};
		
		
		$lgau_query = $DB->query("SELECT class
		                          FROM exp_extensions
		                          WHERE class = 'Lg_addon_updater_ext'
		                            AND enabled = 'y'
		                          LIMIT 1");
		$lgau_enabled = $lgau_query->num_rows ? TRUE : FALSE;
		$check_for_extension_updates = ($lgau_enabled AND $settings['check_for_extension_updates'] == 'y') ? TRUE : FALSE;

		$DSP->body .= $DSP->table_open(
		                                   array(
		                                       'class'  => 'tableBorder',
		                                       'border' => '0',
		                                       'style' => 'margin-top:18px; width:100%'
		                                   )
		                               )

		            . $DSP->tr()
		            . $DSP->td('tableHeading', '', '2')
		            . $LANG->line("check_for_extension_updates_title")
		            . $DSP->td_c()
		            . $DSP->tr_c()

		            . $DSP->tr()
		            . $DSP->td('', '', '2')
		            . '<div class="box" style="border-width:0 0 1px 0; margin:0; padding:10px 5px"><p>'.$LANG->line('check_for_extension_updates_info').'</p></div>'
		            . $DSP->td_c()
		            . $DSP->tr_c()

		            . $DSP->tr()
		            . $DSP->td('tableCellOne', '60%')
		            . $DSP->qdiv('defaultBold', $LANG->line("check_for_extension_updates_label"))
		            . $DSP->td_c()

		            . $DSP->td('tableCellOne')
		            . '<select name="check_for_extension_updates"'.($lgau_enabled ? '' : ' disabled="disabled"').'>'
		            . $DSP->input_select_option('y', $LANG->line('yes'), ($settings['check_for_extension_updates'] == 'y' ? 'y' : ''))
		            . $DSP->input_select_option('n', $LANG->line('no'),  ($settings['check_for_extension_updates'] != 'y' ? 'y' : ''))
		            . $DSP->input_select_footer()
		            . ($lgau_enabled ? '' : NBS.NBS.NBS.$LANG->line('check_for_extension_updates_nolgau'))
		            . $DSP->td_c()
		            . $DSP->tr_c()
		            . $DSP->table_c();
		
		$DSP->body .=   $DSP->qdiv('itemWrapperTop', $DSP->input_submit());
		$DSP->body .=   $DSP->form_c();
	}	
	
	function publish_form_new_tabs($publish_tabs, $weblog_id, $entry_id, $hidden)
	{
		global $EXT, $PREFS, $SESS , $DB, $CURRENT_WEBLOG_ID;

		$settings = $this->_get_settings();
		
		if ($EXT->last_call !== FALSE)
		{
			$publish_tabs = $EXT->last_call;
		}

		$site_id	= $PREFS->ini('site_id');
		
		$query	= $DB->query( "SELECT f.field_id, f.group_id, w.field_group , w.weblog_id
							   FROM exp_weblogs w, exp_weblog_fields f		  
							   WHERE w.weblog_id = " . $weblog_id . " AND w.field_group  = f.group_id 
								ORDER BY f.field_order" );	
		
		$SESS->cache['mx_cache']['json'] = "";
		$tabs  = array();
		$i = 1;
		foreach ($query->result as $row)
			{
				if (isset($settings['ct_'.$row["field_id"]]))  {
					if ($settings['ct_'.$row["field_id"]] != ""){
					
						$tab_label = $settings['ct_'.$row["field_id"]];
						
						if (!isset($tabs[strtolower($tab_label)])) {
							$tabs[strtolower($tab_label)] = "mx_c_tab_".$i;
							$i++;
						}
				
						$publish_tabs[$tabs[strtolower($tab_label)]] = $tab_label;
						
						$SESS->cache['mx_cache'][$weblog_id][$tab_label] = $tabs[strtolower($tab_label)];
						
						$SESS->cache['mx_cache']['json'] = $SESS->cache['mx_cache']['json'].(($SESS->cache['mx_cache']['json'] == '') ? '' : ',').'{"f_id":"'.$row["field_id"].'","tab_id": "'.$tabs[strtolower($tab_label)].'"}';
						
					}
				
				}
			}

			return $publish_tabs;
	}

	/**
	* Adds the tab bolock
	*
	* @param	int $weblog_id The weblog ID for this Publish form
	* @return	string Content of the new tab
	* @see		http://expressionengine.com/developers/extension_hooks/publish_form_new_tabs_block/
	* @since 	Version 2.0.0
	*/
	function publish_form_new_tabs_block($weblog_id)
	{
		global $DB, $EXT, $IN, $PREFS, $SESS, $LANG, $REGX, $IN, $DSP;
		
		$settings = $this->_get_settings();
		
		$tabs_block = ($EXT->last_call !== FALSE) ? $EXT->last_call : '';
	
		if (isset($SESS->cache['mx_cache'][$weblog_id]))
			foreach ($SESS->cache['mx_cache'][$weblog_id] as $row)
			{
				if ($row != "") {
									$tabs_block .= "<div id='block".$row."' style='display:none;'>";
									$tabs_block .= $DSP->div('publishTabWrapper');
									$tabs_block .= $DSP->div('publishBox') . $DSP->div('publishInnerPad');
									$tabs_block .= "<div id='inblock".$row."' >";
									$tabs_block .= $DSP->div_c();
						
									$tabs_block .= $DSP->div_c();
									$tabs_block .= $DSP->div_c();
									$tabs_block .= $DSP->div_c();
									$tabs_block .= $DSP->div_c();					

						}
			}
				
		return $tabs_block;
	}	
	
	function _get_settings($force_refresh = FALSE, $return_all = FALSE)
	{
		global $SESS, $DB, $REGX, $LANG, $PREFS;

	// assume there are no settings
		$settings = FALSE;

		// Get the settings for the extension
		if(isset($SESS->cache['mx'][mx_ct_addon_id]['settings']) === FALSE || $force_refresh === TRUE)
		{
			// check the db for extension settings
			$query = $DB->query("SELECT settings FROM exp_extensions WHERE enabled = 'y' AND class = '" . mx_ct_extension_class . "' LIMIT 1");

			// if there is a row and the row has settings
			if ($query->num_rows > 0 && $query->row['settings'] != '')
			{
				// save them to the cache
				$SESS->cache['mx'][mx_ct_addon_id]['settings'] = $REGX->array_stripslashes(unserialize($query->row['settings']));
			}
		}
		// check to see if the session has been set
		// if it has return the session
		// if not return false
		if(empty($SESS->cache['mx'][mx_ct_addon_id]['settings']) !== TRUE)
		{
			if (isset($SESS->cache['mx'][mx_ct_addon_id]['settings'][$PREFS->ini('site_id')]))
			$settings = ($return_all === TRUE) ?  $SESS->cache['mx'][mx_ct_addon_id]['settings'] : $SESS->cache['mx'][mx_ct_addon_id]['settings'][$PREFS->ini('site_id')];
		}

		return $settings;

	}	
	
		/**
	* Saves the settings from the config form
	*
	* @since	Version 1.3.0
	**/
	function save_settings()
	{
		// make somethings global
		global $DB, $IN, $PREFS, $REGX, $SESS;
		
		// load the settings from cache or DB
		$this->settings = $this->_get_settings(TRUE, TRUE);

		// unset the name
		unset($_POST['name']);
		
		// add the posted values to the settings
		$this->settings[$PREFS->ini('site_id')] = $_POST;


		// update the settings
		$DB->query($sql = "UPDATE exp_extensions SET settings = '" . addslashes(serialize($this->settings)) . "' WHERE class = '" . get_class($this) . "'");

	}
	
	function activate_extension()
	{
		global $DB;

		$default_settings = array(
			'check_for_extension_updates' 	=> 'n'
			);

		$hooks = array(
						'show_full_control_panel_end'		=> 'show_full_control_panel_end',
						'publish_form_new_tabs' => 'publish_form_new_tabs',
						'publish_form_new_tabs_block' => 'publish_form_new_tabs_block',
						'lg_addon_update_register_source' => 'lg_addon_update_register_source',
						'lg_addon_update_register_addon' => 'lg_addon_update_register_addon'
				);
		
		$query = $DB->query("SELECT * FROM exp_sites");

		if ($query->num_rows > 0)
		{
			foreach($query->result as $row)
			{
				$settings[$row['site_id']] = $default_settings;
			}
		}
		
		foreach ($hooks as $hook => $method)
		{
			$sql[] = $DB->insert_string('exp_extensions',
						array(
						'extension_id' => '',
						'class'   => get_class($this),
						'method'  => $method,
						'hook'	 =>$hook,
						'settings'  => addslashes(serialize($settings)),
						'priority'  => 10,
						'version' => $this->version,
						'enabled' => "y"
						)
				  	);
		}
    	
    

		foreach ($sql as $query)
		{
			$DB->query($query);
		}
		
	

		return TRUE;

	}

	function 	show_full_control_panel_end ($out)		
	{
		global $IN,$DB, $PREFS,  $SESS, $EXT;
		
		if($EXT->last_call !== FALSE)
			$out = $EXT->last_call;

		$r = '';			
		
		if($IN->GBL('C', 'GET') == 'publish' OR ( ($IN->GBL('M', 'GET') == 'edit_entry' OR $IN->GBL('M', 'GET') == 'new_entry') AND 	$IN->GBL('C', 'GET') == 'edit' )) {
		if (isset($SESS->cache['mx_cache']["json"])){
			if ($SESS->cache['mx_cache']["json"] != "") {
				
					$r = '
	<script type="text/javascript">

				jQuery(document).ready(function() {
					mx_f = ['.$SESS->cache['mx_cache']["json"].']
					jQuery.each(mx_f , function(i,d){
					block = jQuery("#field_pane_off_" +d.f_id).parent();
					block.hide();	
					jQuery("#inblock"+d.tab_id).html(jQuery("#inblock"+d.tab_id).html()+block.html());
					block.html("");
					});
				});
	</script>
	';

					$out = str_replace("<title>",  $r."<title>", $out); 
				}
			}
		}
			
	
		return $out;
	}

	// --------------------------------
	//  Update Extension
	// --------------------------------

	function update_extension($current='')
	{
		global $DB;

		if ($current == '' OR $current == $this->version)
		{
			return FALSE;
		}

		if ($current > '1.0')
		{
			// Update to next version
		}

		$DB->query("UPDATE exp_extensions 
					SET version = '".$DB->escape_str($this->version)."' 
					WHERE class = '" . get_class($this) . "'");
	}

	// --------------------------------
	//  Disable Extension
	// --------------------------------
	function disable_extension()
	{
		global $DB;
		$DB->query("DELETE FROM `exp_extensions` WHERE class = '" . get_class($this) . "'");
	}

	/**
	* Register a new Addon Source
	*
	* @param array $sources The existing sources
	* @return array The new source list
	*/
	function lg_addon_update_register_source($sources)
	{
		global $EXT;
		// -- Check if we're not the only one using this hook
		if($EXT->last_call !== FALSE)
			$sources = $EXT->last_call;

		if($this->settings['check_for_extension_updates'] == 'y')
		{
			$sources[] = 'http://wiseupstudio.com/versions.xml';;
		}

		return $sources;
	}


	/**
	* Register a new Addon
	*
	* @param array $addons The existing sources
	* @return array The new addon list
	*/
	function lg_addon_update_register_addon($addons)
	{
		global $EXT;
		// -- Check if we're not the only one using this hook
		if($EXT->last_call !== FALSE)
			$addons = $EXT->last_call;

		// add a new addon
		// the key must match the id attribute in the source xml
		// the value must be the addons current version
		if($this->settings['check_for_extension_updates'] == 'y')
		{
			$addons[mx_custom_field_access] = $this->version;
		}

		return $addons;
	}	
}
// END CLASS
/* End of file ext.mx_custom_tabs.php */
/* Location: ./system/extensions/ext.mx_custom_tabs.php */
?>
